#if !defined( _JStringSwitchObj_h )
#define _JStringSwitchObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"





class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JStringSwitchObj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      WHICHSTRING };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JStringSwitchObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual int outputType( int n );
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
  private:

    // inputs
    int whichString;

    // properties
    JString s1;
    JString s2;
    JString s3;
    JString s4;
    JString s5;
    JString s6;
    JString s7;
    JString s8;
    JString s9;
    JString s10;

    // outputs
    JString result;
};


#endif
